#include <stdio.h>
#include <curses.h>




void InitScreen()
/*
   Spielflche initialisieren
*/   
{
    initscr();
    cbreak();			// Tastaturpufferung deaktivieren
    noecho();			// Kein Eingabeecho erzeugen
    start_color();
    keypad(stdscr,TRUE);
    if (has_colors())		// Farben definieren
    {
	init_pair(1,COLOR_RED,COLOR_YELLOW);
	init_pair(2,COLOR_RED,COLOR_BLACK);
	init_pair(3,COLOR_BLACK,COLOR_MAGENTA);
	init_pair(4,COLOR_RED,COLOR_BLUE);
	init_pair(5,COLOR_WHITE,COLOR_BLACK);
	init_pair(6,COLOR_RED,COLOR_CYAN);
    }
    return ;			// Rckkehr
} // InitScreen

void ReadStr(char * str)
/*
   Liest einen String von der Tastatur ein.
*/   
{
    echo();			// Benutzer soll sehen, was er eingibt!
    getstr(str);		// ncurses Befehl zum Strings einlesen
    noecho();
}

void cls()
{
    clear();
} // cls

void PutIcon(int x, int y, char c)
/*
   Ein Zeichen an einer bestimmten Stelle ausgeben
*/   
{
    if (!has_colors()) mvprintw(y,x,"%c",c);	// Keine Farbe verfgbar ? Dann nur Zeichen ausgeben
    else  // Farbe vorhanden!
    {
	switch(c)
	{
	    case 'K': attrset(COLOR_PAIR(6));
		      mvprintw(y,x,"#");
		      break;
	    case 'Z': attrset(COLOR_PAIR(3));
		      mvprintw(y,x,"#");
		      break;
	    case 'P': 
	    case 'G': attrset(COLOR_PAIR(2));
		      mvprintw(y,x," ");
		      break;
	    case '#': attrset(COLOR_PAIR(4));
		      mvprintw(y,x," ");
		      break;
	    case 'E': attrset(COLOR_PAIR(3));
		      mvprintw(y,x," ");
		      break;	      
	    case ' ': attrset(COLOR_PAIR(1));
		      mvprintw(y,x," ");	      
		      break;
	}
	attrset(COLOR_PAIR(5));		// Farben zurcksetzen
    }
    move(0,0);
    return ;
} // PutIcon

void PutIconBig(int x, int y, char c)
/*
   Ein Zeichen an einer bestimmten Stelle ausgeben
*/   
{
    if (!has_colors()) mvprintw(y,x,"%c",c);	// Keine Farbe verfgbar ? Dann nur Zeichen ausgeben
    else  // Farbe vorhanden!
    {
	switch(c)
	{
	    case 'K': attrset(COLOR_PAIR(6));
		      mvprintw(2*y,2*x,"##");
		      mvprintw(2*y+1,2*x,"##");
		      break;
	    case 'Z': attrset(COLOR_PAIR(3));
		      mvprintw(2*y,2*x,"##");
		      mvprintw(2*y+1,2*x,"##");
		      break;
	    case 'P': 
	    case 'G': attrset(COLOR_PAIR(2));
		      mvprintw(2*y,2*x,"  ");
		      mvprintw(2*y+1,2*x,"  ");
		      break;
	    case '#': attrset(COLOR_PAIR(4));
		      mvprintw(2*y,2*x,"  ");
		      mvprintw(2*y+1,2*x,"  ");
		      break;
	    case 'E': attrset(COLOR_PAIR(3));
		      mvprintw(2*y,2*x,"  ");
		      mvprintw(2*y+1,2*x,"  ");
		      break;	      
	    case ' ': attrset(COLOR_PAIR(1));
		      mvprintw(2*y,2*x,"  ");
		      mvprintw(2*y+1,2*x,"  "); 
		      break;
	}
	attrset(COLOR_PAIR(5));		// Farben zurcksetzen
    }
    move(0,0);
    return ;
} // PutIconBig

void PrintText(int x, int y, char *text)
/*
   Text an der gewnschten Position ausgeben
*/   
{
    mvprintw(y,x,text);
} // PrintText

void MoveToXY(int x, int y)
/*
   Cursor an eine Stelle des Bildschirms bewegen
*/   
{
    move(y,x);
} // MoveToXY

int CloseScreen()
/*
   Konsole zurckgeben
*/   
{
    echo();
    return endwin();		// Rckkehr zur Konsole
} // CloseScreen

char GetKey()
/*
   Liest ein Zeichen von stdin ein
*/   
{
    int c = getch();
    switch(c)
    {
	case KEY_UP: c = 'w'; break;
	case KEY_DOWN: c = 's'; break;
	case KEY_RIGHT: c = 'd'; break;
	case KEY_LEFT: c = 'a'; break; 		
    }
    return (char)c;
} // GetKey
