#include <termios.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

#include "dispterm.h"

void PutIcon(int x, int y, char c)
{
    printf("\033[%d;%dH",y+1,x+1);
	switch(c)
	{
	    case 'K':
		printf("\033[31m\033[46m#\033[0m");
		break;
	    case 'Z':
		printf("\033[30m\033[45m#\033[0m");
		break;
	    case 'E':
		printf("\033[45m \033[0m");
		break;
	    case 'P':
	    case 'G':
		printf("\033[40m \033[0m");
		break;
	    case ' ':
		printf("\033[43m \033[0m");
		break;
	    case '#':
		printf("\033[44m \033[0m");
		break;
	}
	fflush(stdout);
}

void PutIconBig(int x, int y, char c)
{
        printf("\033[%d;%dH",2*(y+1),2*(x+1));
	switch(c)
	{
	    case 'K':
		printf("\033[31m\033[46m##\033D\033[2D##\033[0m");
		break;
	    case 'Z':
		printf("\033[30m\033[45m##\033D\033[2D##\033[0m");
		break;
	    case 'E':
		printf("\033[45m  \033D\033[2D  \033[0m");
		break;
	    case 'P':
	    case 'G':
		printf("\033[40m  \033D\033[2D  \033[0m");
		break;
	    case ' ':
		printf("\033[43m  \033D\033[2D  \033[0m");
		break;
	    case '#':
		printf("\033[44m  \033D\033[2D  \033[0m");
		break;
	}
	fflush(stdout);
}

void cls()
{
    printf("\033c");
}

void ReadStr(char * str)
{
    scanf("%s",str);
}

void PrintText(int x, int y, char * text)
{
    printf("\033[%d;%dH",y+1,x+1);
    printf("%s",text);
    fflush(stdout);
}

int GetKey()
/*
   Liest ohne Echo ein Zeichen von der Tastatur und gibt dieses zurck.
   Wird eine Pfeiltaste eingelesen, wird a,w,s oder d zurckgegeben.
*/   
{
    // Variablendefinition
    struct termios origstate, changedstate;
    char buffer[10];
    int rd;
    char ch;
       
    /* alten Terminalzustand speichern (von stdin = id 0) */
    if (tcgetattr(0, &origstate) != 0)
	printf("tcgetattr failed");
    changedstate = origstate;

    /* neuen Terminalzustand setzen (von stdin = id 0) */
    changedstate.c_lflag &= ~ICANON; /* disable canonical input */
    changedstate.c_lflag &= ~ECHO;	 /* disable output */
    changedstate.c_cc[VMIN] = 1;	 /* min = 1 */
    changedstate.c_cc[VTIME] = 1;	 /* time = 1/10 sec */
    if (tcsetattr(0, TCSANOW, &changedstate) != 0)
	printf("tcsetattr failed");

    /* Zeichen einlesen */
    //int ch = cin.get();
    
//	int ch = getchar();
    rd = read(STDIN_FILENO,&ch,1);	// Genau 1 Zeichen lesen
    if (rd < 1) return 0;

   if (ch==27) 				// Escape-Sequenz gelesen?
   {					// Dann Sondertasten auswerten
       rd  = read(STDIN_FILENO, buffer, 3);	// Sondertaste einlesen
       buffer[rd]=0;
       if (!strcmp(buffer,"[D")) ch = 'a';	// Pfeil links gedrckt
       if (!strcmp(buffer,"[C")) ch = 'd';	// Pfeil rechts gedrckt
       if (!strcmp(buffer,"[B")) ch = 's';	// Pfeil unten gedrckt
       if (!strcmp(buffer,"[A")) ch = 'w';	// Pfeil oben gedrckt
   }

    /* alten Terminalzustand wiederherstellen (von stdin = id 0) */
    if (tcsetattr(0, TCSANOW, &origstate) != 0)
	printf("tcsetattr failed");

   return ch;	// entspr. Zeichen zurck!
} // GetKey


void MoveToXY(int x, int y)
{
    printf("\033[%d;%dH",y+1,x+1);
    fflush(stdout);
}

void InitScreen()		// eigentlich berflssig; werden aber verlangt.
{
}
void CloseScreen()
{
    cls();
}
