#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "files.h"
#include "game.h"
#include "displaylab.h"



// Globale Variablen
    char filename[50];

void PrintKeys(int x, int y)
{
    char c;
    PrintText(x,y,   "w a s d 	:		Cursor bewegen");
    PrintText(x,y+1, "k		:		Kiste einfgen");
    PrintText(x,y+2, "z		:		Zielfeld einfgen");
    PrintText(x,y+3, "p		:		Spieler einfgen");
    PrintText(x,y+4, "l		:		Feld leeren");
    PrintText(x,y+5, "m		:		Mauer einfgen");
    PrintText(x,y+6, "M		:		MauerModus (de)aktivieren");
    PrintText(x,y+7, "S		:		Labyrinth speichern");
    PrintText(x,y+8, "q		:		beenden");
    PrintText(x,y+10,"Bitte eine Taste drcken, um zurckzukehren.");
    c = GetKey();
    return ;
} // PrintKeys
    
void ModifyLevel(pLab lab)
/*
   Bestehendes Labyrinth verndern, oder neues erstellen
*/   
{
   int posX=0, posY=0;
   int PlayerPosX=0, PlayerPosY=0;
   char c=0;
   int WallDrawing=0;
   void (*DrawFct)(int x, int y, char c);  // Funktion zur Ausgabe von Zeichen
   int infotxt=1;
    
   DrawFct = &PutIconBig;
   
   cls();
   if (lab==0)		// neues Labyrinth erstellen?
   {
       CreateLabyrinth(&lab,1,1);
       SetDrawFct(&lab,DrawFct);
       SetSquare(&lab,' ',0,0);
   }
   else 
   {
       SetDrawFct(&lab,DrawFct);
       PlayerPosX = GetPosX(&lab);
       PlayerPosY = GetPosY(&lab);
       PrintLabyrinth(&lab);	// sonst altes Labyrinth ausgeben
   }

   PrintText(1,5,"Um die Tastenbelegung zu erfahren, bitte '?' drcken!");
   
   while (c!='q')
   {
       if (DrawFct==&PutIcon) MoveToXY(posX,posY);
       else MoveToXY(2*posX+2,2*posY+1);		// Cursor richtig positionieren
       c = GetKey();	// Benutzereingabe einlesen

       switch(c)		// Hier nur Bewegung ausfhren
       {			// Elemente einfgen wird spter behandelt
	   case 'd':	posX++; break;	
	   case 'a':	posX--; break;
	   case 'w':	posY--; break;
	   case 's':	posY++; break;
       }
       if (posX<0) posX=0;		// Positiv bleiben; sonst gibt es evtl. Probleme mit Speicherreservierung
       if (posY<0) posY=0;

       if ((WallDrawing)&&(c!='M')) 
       {
	   c = 'm';  // Mauer einfgen, wenn im Mauermodus
       }
       if ((!WallDrawing)&&(c=='M')) 
       {
	   WallDrawing = ~WallDrawing;  // Mauerzeichnemodus aktivierren
	   c = 'm';  // Mauer einfgen, wenn Mauermodus aktiviert wird
       }
       
       if ((c=='k')||(c=='m')||(c=='l')||(c=='z')||(c=='p')) 	// Element eigefgt?
       {							
	   if ((posX+1>sizeX(&lab))||(posY+1>sizeY(&lab)))	// Position nicht mehr im reserv. Lab. Bereich?
	   {							 // mehr Speicher reservieren und initialisieren 
	       ResizeLabyrinth(&lab,posX+1,posY+1);	// Labyrinth vergrern
	       PrintLabyrinth(&lab);		// Labyrinth mit neuen Feldern ausgeben
	       
	   } //if
       } // Speicherreservierung zuende 
       
        switch(c)	// Hier Elemente einfgen / andere Wnsche des Benutzers bearbeiten
	{    
	   case 'k':			// Kiste
			if (GetSquare(&lab,posX,posY)=='E') SetSquare(&lab,'Z',posX,posY);
			else SetSquare(&lab,'K',posX,posY);	// Kiste auf Zielfeld gestellt?
			break;
	   case 'm':			// Mauer
			SetSquare(&lab,'#',posX,posY);
			break;
	   case 'l':			// leer
			SetSquare(&lab,' ',posX,posY);
			break;
	   case 'z':			// Ziel
			SetSquare(&lab,'E',posX,posY);
			break;
	   case 'p':			// Spieler
			if (GetSquare(&lab,posX,posY)=='E') SetSquare(&lab,'G',posX,posY);
			else SetSquare(&lab,'P',posX,posY);	// Spieler auf Zielfeld gestellt?
			if ((PlayerPosX!=0)||(PlayerPosY!=0)) SetSquare(&lab,' ',PlayerPosX,PlayerPosY);
			PlayerPosX = posX; PlayerPosY  = posY;
			PrintLabyrinth(&lab);
			break;

	   case 'S':			// Speichern
		       if (filename[0]==0) GetFileName(0,sizeY(&lab)+5,filename,0);
		       if (!strstr(filename,".lab")) strcat(filename,".lab");
	       	       SaveLevel(&lab,filename);	    // aus files.h   
		       PrintText(0,2*sizeY(&lab)+1,"gespeichert. Bitte Taste drcken.");
		       GetKey();
		       PrintText(0,2*sizeY(&lab)+1,"                                 ");
		       break;
	   case 'M':			// Dauerhaft Mauern malen
		       WallDrawing = ~WallDrawing;  // bitw. kompl.
		       break;
	   case 'G':   SetDrawFct(&lab,&PutIconBig); cls(); PrintLabyrinth(&lab); // Groe Bildschirmausgabe
		       DrawFct = &PutIconBig;	// Lokale Draw-Fkt.
		       break;
	   case 'g':   SetDrawFct(&lab,&PutIcon); cls(); PrintLabyrinth(&lab);  // Kleine Bildschirmausgabe
		       DrawFct = &PutIcon;	// Lokale Draw-Fkt.
		       break;	       
	       
	   case '?':   cls();
		       PrintKeys(5,5);    	       
		       cls();
		       PrintLabyrinth(&lab);
	   default:    break;	       
		       
       } // switch
       
       if ((posX<sizeX(&lab))&&(posY<sizeY(&lab))) 			// Cursor noch im Lab. Bereich?
	  (*DrawFct)(posX,posY,GetSquare(&lab,posX,posY));	// dann Ausgabe des akt. Feldes
       if (infotxt) 
       {	// Wenn der Informationstext noch im Fenster steht, dann jetzt lschen
	   PrintText(0,5,"                                                                            ");
	   infotxt = 0;
       }
   }  // Schleifenende 
   
    DeleteLabyrinth(&lab);
   return; 
} // ModifyLevel()


int main(int argc, char * argv[])
{
    // Variablendefinitionen
    pLab lab;
    filename[0]=0;
    
    InitScreen();		// Bildschirm initialisieren
    if (argc > 1)  // wurde Argument bergeben?
	strcpy(filename,argv[1]);
    else
    {
	cls();
	PrintText(0,5,"Name des Labyrinths:");	
	GetFileName(0,10,filename,0);
    }
    
    if (FileExists(filename)) 
    {
	LoadLevel(&lab,filename);	
    }
    
    else lab = 0;

    ModifyLevel(lab);

    
    CloseScreen();		// Bildschirm wieder normal
    
    return 0;	// Erfoldgreich beenden!
}  // main()

